#         Portable Batch System (PBS) Software License
# 
# Copyright (c) 1999, MRJ Technology Solutions.
# All rights reserved.
# 
# Acknowledgment: The Portable Batch System Software was originally developed
# as a joint project between the Numerical Aerospace Simulation (NAS) Systems
# Division of NASA Ames Research Center and the National Energy Research
# Supercomputer Center (NERSC) of Lawrence Livermore National Laboratory.
# 
# Redistribution of the Portable Batch System Software and use in source
# and binary forms, with or without modification, are permitted provided
# that the following conditions are met:
# 
# - Redistributions of source code must retain the above copyright and
#   acknowledgment notices, this list of conditions and the following
#   disclaimer.
# 
# - Redistributions in binary form must reproduce the above copyright and 
#   acknowledgment notices, this list of conditions and the following
#   disclaimer in the documentation and/or other materials provided with the
#   distribution.
# 
# - All advertising materials mentioning features or use of this software must
#   display the following acknowledgment:
# 
#   This product includes software developed by NASA Ames Research Center,
#   Lawrence Livermore National Laboratory, and MRJ Technology Solutions.
# 
#         DISCLAIMER OF WARRANTY
# 
# THIS SOFTWARE IS PROVIDED BY MRJ TECHNOLOGY SOLUTIONS ("MRJ") "AS IS" WITHOUT 
# WARRANTY OF ANY KIND, AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, AND NON-INFRINGEMENT ARE EXPRESSLY DISCLAIMED.
# 
# IN NO EVENT, UNLESS REQUIRED BY APPLICABLE LAW, SHALL MRJ, NASA, NOR
# THE U.S. GOVERNMENT BE LIABLE FOR ANY DIRECT DAMAGES WHATSOEVER,
# NOR ANY INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
# CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
# OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
# USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
# 
# This license will be governed by the laws of the Commonwealth of Virginia,
# without reference to its choice of law rules.
################################################################################
# state: defines the layout and functions of the select job state dialog box.
proc state {} {
  global LABELFONT stateDialogBox activeWindow selv

  busy_cursor
## Bring up the standard Dialog box ##
  set stateDialogBox ".states"
  set dbox [popupDialogBox $stateDialogBox "Select Job States Criteria" 1 "" "" 1]
  set activeWindow($stateDialogBox) 1
  set dbox_top    [lindex $dbox 0]
  set dbox_bottom [lindex $dbox 1]

## TOP PART ##
  frame $dbox_top.header -height 10m -width 10m
  frame $dbox_top.footer -height 10m -width 10m

  frame $dbox_top.s

  pack $dbox_top.s -padx 2m -pady 5m

  
  set checkbox [buildCheckboxes $dbox_top.s \
                             { {{rstate  R} {qstate Q} {wstate W} \
                               {hstate H}  {estate E} {tstate T}} } grid 5 "Job State  MATCH"]

  set checkboxFrame [lindex $checkbox 0]
  set checkboxR [lindex $checkbox 1]
  set checkboxQ [lindex $checkbox 2]
  set checkboxW [lindex $checkbox 3]
  set checkboxH [lindex $checkbox 4]
  set checkboxE [lindex $checkbox 5]
  set checkboxT [lindex $checkbox 6]

  $checkboxR configure -variable selv(Rstate) -onvalue R \
                            -offvalue ""
  $checkboxQ configure -variable selv(Qstate) -onvalue Q \
                            -offvalue ""
  $checkboxW configure -variable selv(Wstate) -onvalue W \
                            -offvalue ""
  $checkboxH configure -variable selv(Hstate) -onvalue H \
                            -offvalue ""
  $checkboxE configure -variable selv(Estate) -onvalue E \
                           -offvalue ""
  $checkboxT configure -variable selv(Tstate) -onvalue T \
                           -offvalue ""

## BOTTOM PART ##
  set cmdButtons \
  [buildCmdButtons $dbox_bottom {{{ok ok} {help help}}} x 2m 18 3]

  set cmdFrame  [lindex $cmdButtons 0]
  set cmdOk     [lindex $cmdButtons 1]
  set cmdHelp   [lindex $cmdButtons 2]

  $cmdHelp configure -command {xpbs_help select.states $stateDialogBox}

  $cmdOk configure -command {
    set jstates "$selv(Rstate)$selv(Qstate)$selv(Wstate)$selv(Hstate)$selv(Estate)$selv(Tstate)"
    if {[string compare $jstates ""] == 0} {
      popupInfoBox $stateDialogBox "Please pick a job state."
      return	
    } else {
      if { [string compare $jstates "RQWHET"] == 0 } {
        set selv(states) "Job_States: -ANY-"
      } else {
        set selv(states) "Job_States: $jstates"
      }
    }
    destroy $stateDialogBox
  }

## SET DEFAULT OPTION ###
  set arg [lindex $selv(states) 1]
  switch -regexp -- $arg {
    "-ANY-" {
	set selv(Rstate) R
	set selv(Qstate) Q
	set selv(Wstate) W
	set selv(Hstate) H
	set selv(Estate) E
	set selv(Tstate) T
    }
    "R|Q|W|H|E|T" {
	if [regexp "R" $arg] {
	  set selv(Rstate) R
	}
	if [regexp "Q" $arg] {
	  set selv(Qstate) Q
	}
	if [regexp "W" $arg] {
	  set selv(Wstate) W
	}
	if [regexp "H" $arg] {
	  set selv(Hstate) H 
	}
	if [regexp "E" $arg] {
	  set selv(Estate) E
	}
	if [regexp "T" $arg] {
	  set selv(Tstate) T
	}
    }
  }

  register_default_action $stateDialogBox $cmdOk
  tkwait visibility $stateDialogBox
  remove_busy_cursor
  catch {tkwait window $stateDialogBox}
  set activeWindow($stateDialogBox) 0
}
